# Generated by Django 3.0.3 on 2021-03-31 15:50

from django.db import migrations


class Migration(migrations.Migration):

    dependencies = [
        ('relatorios', '0004_auto_20210329_1428'),
    ]

    operations = [
        # TerritorioAgregado
        migrations.RunSQL(
            """
            DROP VIEW IF EXISTS relatorios_territorioagregado;
            CREATE OR REPLACE VIEW relatorios_territorioagregado AS
            SELECT t.id,
                   t.nome,
                   t.qtde_familias,
                   t.ano_fundacao,
                   t.status_id,
                   t.criacao,
                   t.ultima_alteracao,
                   t.municipio_referencia_id,
                   t.publico,
                   ST_Area(t.poligono::geography) AS area,
                   ST_AsKML(t.poligono) AS poligono_kml,
                   mun.nome AS municipio_nome,
                   est.uf   AS estado_uf,
                   est.nome AS estado_nome,
                   st.nome  AS status_nome,
                   tc.tipos_comunidade,
                   auso.tipos_areas_de_uso,
                   confs.tipos_conflitos
            FROM main_territorio t
                     JOIN main_municipio mun ON t.municipio_referencia_id = mun.id
                     JOIN main_estado est ON mun.estado_id = est.id
                     LEFT JOIN main_territoriostatus st ON t.status_id = st.id
                     LEFT JOIN (SELECT terr.id,
                                       string_agg(tpcom.nome, ', ' ORDER BY tpcom.nome) AS tipos_comunidade
                                FROM main_territorio_tipos_comunidade ttc
                                         JOIN main_tipocomunidade tpcom ON ttc.tipocomunidade_id = tpcom.id
                                         JOIN main_territorio terr ON ttc.territorio_id = terr.id
                                WHERE tpcom.deleted IS NULL
                                GROUP BY terr.id
            ) tc ON tc.id = t.id
                     LEFT JOIN (
                SELECT a1.id,
                       string_agg(a1.nome, ', ' ORDER BY a1.nome) AS tipos_areas_de_uso
                FROM (
                         SELECT DISTINCT terr.id,
                                         tau.nome
                         FROM main_areadeuso au
                                  JOIN main_territorio terr ON au.territorio_id = terr.id
                                  JOIN main_tipoareadeuso tau ON au.tipo_area_de_uso_id = tau.id
                         WHERE tau.deleted IS NULL
                     ) a1
                GROUP BY a1.id
            ) auso ON auso.id = t.id
                     LEFT JOIN (
                SELECT a2.id,
                       string_agg(a2.nome, ', ' ORDER BY a2.nome) AS tipos_conflitos
                FROM (
                         SELECT DISTINCT terr.id,
                                         tcf.nome
                         FROM main_conflito cf
                                  JOIN main_territorio terr ON cf.territorio_id = terr.id
                                  JOIN main_tipoconflito tcf ON cf.tipo_conflito_id = tcf.id
                         WHERE tcf.deleted IS NULL
                     ) a2
                GROUP BY a2.id
            ) confs ON confs.id = t.id
            WHERE t.deleted IS NULL
            ORDER BY t.id
            """
        )
    ]
